Generator = require('./generators.js').Generator;
Semantic = require('./semantics.js').Semantic;
module.exports = {
  contexts: [{"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "cheeseburger", "marker": "food", "word": "cheeseburger"}, "store": {"marker": "whitespot", "word": "whitespot"}}, {"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "fries", "marker": "food", "word": "fries"}, "store": {"marker": "whitespot", "word": "whitespot"}}],
  objects: {           newTank:
          () => { 
            return { name: 'tank1', 'id': 'tank1id' } 
          }
        ,
           newBuilding:
          () => { 
            return { name: 'building1', 'id': 'building1id' } 
          }
        ,
           },
  expected: ["order for cheeseburger from Whitespot", "order for fries from Whitespot"],
  expected_semantics: [{"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "cheeseburger", "marker": "food", "word": "cheeseburger"}, "store": {"marker": "whitespot", "word": "whitespot"}}, {"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "fries", "marker": "food", "word": "fries"}, "store": {"marker": "whitespot", "word": "whitespot"}}],
  generators: [
    new Generator( (context) => context.marker.endsWith('Concept') && context.number > 0, (g, context) => `${g(context.number)} ${g(context.word)}` ),
    new Generator( (context) => context.marker.endsWith('Concept') && !('number' in context), (g, context) => `${g(context.word)}` ),
    new Generator( (context) => context.marker.endsWith('Concept') && context.number == 'all', (g, context) => `all ${g(context.word)}` ),
    new Generator( (context) => context.marker == 'article' && context.gender == 'm', (g, context) => 'le' ),
    new Generator( (context) => context.marker == 'article' && context.gender == 'f', (g, context) => 'la' ),
    new Generator( (context) => context.isProperty && context.language == 'french', (g, context) => `${g({marker: 'article', gender: context.gender})} ${g(context.propertyName)} de ${g(context.object)} est ${g(context.value)}` ),
    new Generator( (context) => context.isProperty, (g, context) => `the ${context.propertyName} of ${g(context.object)} is ${g(context.value)}` ),
    new Generator( (context) => context.marker == 'number', (g, context) => `${g(context.value)}` ),
    new Generator( (context) => context.marker == 'equal', (g, context) => `${g(context.objects[1])}` ),
    new Generator( (context) => context.marker == 'conj', (g, context) => `${context.value.map( (c) => g(c) ).join('and')}` ),
    new Generator( (context) => context.marker == 'move' && context.language == 'french', (g, context) => `deplacez ${g(context.thing)} vers ${g(context.place)}` ),
    new Generator( (context) => context.marker == 'move', (g, context) => `move ${g(context.thing)} to ${g(context.place)}` ),
    new Generator( (context) => context.marker == 'create', (g, context) => `create ${g(context.klass)}` ),
    new Generator( (context) => context.marker == 'destroy', (g, context) => `destroy ${g(context.name)}` ),
    new Generator( (context) => context.marker == 'alias' && context.language == 'french', (g, context) => `appellez ${g(context.thing)} ${g(context.name)}` ),
    new Generator( (context) => context.marker == 'alias', (g, context) => `call ${g(context.thing)} ${g(context.name)}` ),
    new Generator( (context) => context.marker == 'commander', (g, context) => 'commander' ),
    new Generator( (context) => context.marker == 'commandeur', (g, context) => 'commandeur' ),
    new Generator( (context) => context.marker == 'cia', (g, context) => 'CIA' ),
    new Generator( (context) => context.marker == 'stop', (g, context) => `stop ${g(context.thing)}` ),
    new Generator( (context) => context.marker == 'destroy', (g, context) => `destroy ${g(context.name)}` ),
    new Generator( (context) => context.marker == 'week' && context.duration == 1, (g, context) => `${context.duration} week` ),
    new Generator( (context) => context.marker == 'week' && context.duration > 1, (g, context) => `${context.duration} weeks` ),
    new Generator( (context) => context.marker == 'earn', (g, context) => `${g(context.who)} earns ${g(context.amount)} ${g(context.units)} per ${context.period}` ),
    new Generator( (context) => context.marker == 'worked', (g, context) => `${g(context.who)} worked ${ g({ marker: context.units, duration: context.duration}) }` ),
    new Generator( (context) => context.marker == 'response', (g, context) => `${context.who} earned ${context.earnings} ${context.units}` ),
    new Generator( (context) => context.marker == 'wantWhitespot', (g, context) => `order for ${g(context.items)} from ${g(context.store)}` ),
    new Generator( (context) => context.marker == 'wantMcDonalds', (g, context) => `order for ${g(context.items)} from ${g(context.store)}` ),
    new Generator( (context) => context.marker == 'food' && context.number > 0, (g, context) => `${g(context.number)} ${g(context.name)}` ),
    new Generator( (context) => context.marker == 'food' && !('number' in context), (g, context) => `${g(context.name)}` ),
    new Generator( (context) => context.marker == 'whitespot', (g, context) => 'Whitespot' ),
    new Generator( (context) => context.marker == 'mcdonalds', (g, context) => 'McDonalds' ),
  ],
  semantics: [
    new Semantic( (global, context) => context.marker == 'create'
, (global, context) => { 
    if (context.klass.marker === 'tankConcept') {
      if (!global.newTanks) {
        global.newTanks = []
      }
      const tank = global.newTank(context)
      if (!global.mentioned) {
        global.mentioned = []
      }
      global.mentioned.push({ marker: 'tankConcept', word: tank.name, id: tank.id })
    } else if (context.klass.marker === 'buildingConcept') {
      if (!global.newBuildings) {
        global.newBuildings = []
      }
      const building = global.newBuilding(context)
      if (!global.mentioned) {
        global.mentioned = []
      }
      global.mentioned.push({ marker: 'buildingConcept', word: building.name, id: building.id })
    }
     } ),
    new Semantic( (global, context) => context.marker == 'earn' && context.isQuery, (global, context) => { 
      context.marker = 'response'; 
      var employee_record = global.employees.find( (er) => er.name == context.who )
      let totalIncome = 0
      global.workingTime.forEach( (wt) => {
        if (wt.name == context.who) {
          totalIncome += employee_record.earnings_per_period * wt.number_of_time_units
        }
      });
      context.earnings = totalIncome
     } ),
    new Semantic( (global, context) => context.marker == 'earn', (global, context) => { 
      if (! global.employees ) {
        global.employees = []
      }
      global.employees.push({ name: context.who, earnings_per_period: context.amount, period: context.period, units: 'dollars' })
     } ),
    new Semantic( (global, context) => context.marker == 'worked', (global, context) => { 
      if (! global.workingTime ) {
        global.workingTime = []
      }
      global.workingTime.push({ name: context.who, number_of_time_units: context.duration, time_units: context.units })
     } ),
    new Semantic( (global, context) => context.pullFromContext
, (global, context) => { 
    const object = global.mentioned[0]
    global.mentioned.shift()
    Object.assign(context, object)
    delete context.pullFromContext
     } ),
  ]
};